type TExercise
  as string title          ' displayed on the button (main window)
  as string listname       ' used for the name of the save file
  ' listname can be "full", but then it shouldn't change anything in the word positions
  as string settingString  ' user preferences; e. g. word groups that should be used
  as long opt              ' for free use
  as TList fullList        ' all words used for the exercise
  as TList currentList     ' words currently in use
  as sub(as TExercise) callback               ' main function of the exercise
  as function(as TExercise) as string info    ' info string displayed in the main window
  as sub(as TExercise, as long = 1) settings  ' function to set the preferences
  ' In the beginnig SETTINGSTRING is read from file, and SETTINGS(exercise, 0) is called
  ' to allow the function to initialize (especially to execute SETTINGSTRING and set CURRENTLIST).
  ' The main program will call SETTINGS(exercise, 1) to enter the setting window.
  ' You may call the function from CALLBACK and choose a different parameter to disable some options.
  declare constructor
  declare constructor(title as string, listname as string, opt as long, _
          callback as sub(as TExercise), _
          info as function(as TExercise) as string, _
          settings as sub(as TExercise, as integer = 1))
  declare operator cast as string
  declare sub updateLists
end type

constructor TExercise
end constructor

constructor TExercise(t as string, l as string, o as long, c as sub(as TExercise), _
                      i as function(as TExercise) as string, s as sub(as TExercise, as integer = 1))
  title    = t
  listname = l
  opt      = o
  callback = c
  info     = i
  settings = s
end constructor

operator =(e1 as TExercise, e2 as TExercise) as integer
  return e1.title = e2.title
end operator

operator TExercise.cast as string
  return title
end operator

sub TExercise.updateLists
  fullList.update
  dim as TListPoint listPoint
  dim as TList tempList
  tempList.list.addAll(currentList.list)
  currentList.list.clear
  currentList.size = 0
  currentList.notChecked = 0
  foreach(TListPoint, listPoint, fullList.list)
    if tempList.list.contains(listPoint) then
      currentList.list.add(listPoint)
      currentList.size += 1
      if listPoint.position <= now then currentList.notChecked += 1
    end if
  nexteach
end sub
