' module: list words and various informations (sorted) 
#include once "include/showWords.bi"

enum DICTSORT
  word = 1, translate, id, diffWord, diffTrans, mark
end enum
namespace DICTOPT
  const word = 1, translate = 2, special = 4
end namespace

declare sub dictionary(exercise as TExercise)
globalOptions.add(TExercise(utf("Wörterbuch"), "dict", 0, @dictionary, 0, @chooseWords))

function dictionarySort(list as mdList(TListPoint), sort as DICTSORT, _
                        search as string, searchOpt as integer) as mdList(TListPoint)
  dim as integer i, retSize = 0, size = list.size*list.size-1
  dim as TListPoint lp1
  dim as TWord w1, w2
  dim as mdList(TListPoint) ret
  dim as integer found
  foreach(TListPoint, lp1, list)
    w1 = globallist.get(lp1.id)
    if len(search) then
      found = 0
      if searchOpt and DICTOPT.word then
        if instr(utf(w1.word), search) then found = -1
      end if
      if found = 0 andalso searchOpt and DICTOPT.translate then
        for i as integer = 0 to w1.translate.size-1
          if instr(utf(w1.translate.get(i)), utf(search)) then found = -1 : exit for
        next
      end if
      if found = 0 andalso searchOpt and DICTOPT.special then
        ' TODO
      end if
      if found = 0 then continue while
    end if
    if w1.word = "" then continue while
    for i = 0 to retSize-1
      w2 = globallist.get(ret.get(i).id)
      select case sort
        case DICTSORT.translate
          if lcase(w1.translate.get(0)) < lcase(w2.translate.get(0)) then exit for
        case DICTSORT.id
          if w1.id < w2.id then exit for
        case DICTSORT.diffWord
          if w1.levelA < w2.levelA then exit for
        case DICTSORT.diffTrans
          if w1.levelB < w2.levelB then exit for
        case DICTSORT.mark
          if w1.mark > 0 and (w1.mark < w2.mark or w2.mark = 0) then exit for
        case else
          if lcase(w1.word) < lcase(w2.word) then exit for
      end select
    next
    if i < retSize then ret.add(i, lp1) else ret.add(lp1)
    retSize += 1
    drawProgress(100, SCREEN_Y\2-10, SCREEN_X-200, 20, retSize*retSize, size-1)
  nexteach
  return ret
end function

function dictionaryOutput(x as integer, y as integer, x2 as integer, h as integer, _
                        word as TWord, opt as integer) as integer
  dim as integer col, ret = word.translate.size
  dim as string irr = replace(word.map.get("irr"), "→", "->")
  if len(irr) and ret = 1 then ret = 2
  if opt mod 32 then
    select case word.map.get("genus")
      case "m"  : col = &hff
      case "f"  : col = &hff0000
      case else : col = 0
    end select
    printFT x, y, utf(word.word), font, opt mod 32, col
    if len(irr) then
      printFT x, y+15, "  (" & utf(irr) & ")", font, opt mod 32
      if opt mod 32 then
        dim as FB.Image ptr attImg = imagecreate(16, 16)
        bload exepath & "/img/attention.bmp", attImg
        put (x-14, y), attImg, pset
        imagedestroy attImg
      end if
    end if
    for i as integer = 0 to word.translate.size-1
      printFT x2, y+i*15, utf(word.translate.get(i)), font, opt mod 32
    next
    printFT 2*x2-x, y, "Lektion " & word.lession\100 & "." & (word.lession mod 100), font, opt mod 32
    printFT 2*x2-x+100, y, "Stand " & word.levelA & " / " & word.levelB, font, opt mod 32
    if word.mark > 0 then
      dim as FB.Image ptr markImg
      markImg = imagecreate(16, 16)
      bload exepath & "/img/" & word.mark & ".bmp", markImg
      put (x-30, y), markImg, pset
      imagedestroy markImg
    end if
  end if
  return ret*h
end function

sub dictionary(exercise as TExercise)
  static as integer sorted = 0, searchOpt = 1, spec = 0
  static as string searchString
  dim as integer index, count, mx, my, mb, mw, wheel, upState, downState
  dim as integer tempInt, page = 0
  dim as uinteger col
  dim as string tempstring, key
  dim as TWord word
  enum
    posNone = 0, posSetting, posHelp, posUp, posDown, posBack, posSearch, posSearchWord, posSearchTrans, posSort
  end enum

  if sorted = 0 then
    cls
    exercise.fullList.load("default-es-de")
    exercise.currentList.list = dictionarySort(exercise.fullList.list, DICTSORT.word, searchString, searchOpt)
    exercise.fullList.list.clear
    exercise.fullList.list.addAll exercise.currentList.list
    exercise.fulllist.save
    sorted = DICTSORT.word
  elseif searchString = "" then
    exercise.currentList.list.addAll(exercise.fullList.list)
  end if
  count = exercise.fullList.size

  dim as integer LBx = 0, LBy = 550, LBw = 140, LBh = 30, LBpx = 20, LBpy = 10
  dim as integer SBx = 650, SBy = 50, SBw = 120, SBh = 30, SBp = 20
  dim dictGui as TGui, event as TGuiEvent
  dictGui.buttons.add _
      TGuiButton(possort+DICTSORT.word, LBx+LBw+LBpx, LBy, LBw, LBh, "Wort spanisch", chr(255, 61))
  dictGui.buttons.add _
      TGuiButton(possort+DICTSORT.translate, LBx+2*(LBw+LBpx), LBy, LBw, LBh, "Wort deutsch", chr(255, 62))
  dictGui.buttons.add _
      TGuiButton(possort+DICTSORT.id, LBx+3*(LBw+LBpx), LBy, LBw, LBh, "nach Lektion", chr(255, 63))
  dictGui.buttons.add _
      TGuiButton(possort+DICTSORT.diffWord, LBx+(LBw+LBpx), LBy+LBh+LBpy, LBw, LBh, "Stand spanisch", chr(255, 64))
  dictGui.buttons.add _
      TGuiButton(possort+DICTSORT.diffTrans, LBx+2*(LBw+LBpx), LBy+LBh+LBpy, LBw, LBh, "Stand deutsch", chr(255, 65))
  dictGui.buttons.add _
      TGuiButton(possort+DICTSORT.mark, LBx+3*(LBw+LBpx), LBy+LBh+LBpy, LBw, LBh, "nach Markierung", chr(255, 66))
  dictGui.buttons.add _
      TGuiButton(posBack, LBx+4*(LBw+LBpx), LBy+LBh+LBpy, LBw, LBh, utf("zurück"), chr(27))
  dictGui.buttons.add _
      TGuiButton(posUp,      exepath & "/img/up.bmp", LBx+30, LBy, 31, 30, chr(255, 73))
  dictGui.buttons.add _
      TGuiButton(posDown,    exepath & "/img/down.bmp", LBx+70, LBy, 31, 30, chr(255, 81))
  dictGui.buttons.add _
      TGuiButton(posHelp,    exepath & "/img/help.bmp", LBx+25, LBy+40, 40, 40, chr(255, 59), "", GuiState.noBorder)
  dictGui.buttons.add _
      TGuiButton(posSetting, exepath & "/img/settings.bmp", LBx+65, LBy+40, 40, 40, chr(9), "", GuiState.noBorder)
  dictGui.buttons.add _
      TGuiButton(posSearch, SBx, SBy, SBw, SBh, utf("Suche"), chr(255, 60))
  dictGui.buttons.add _
      TGuiButton(posSearchWord,  SBx, SBy+2*(SBh+SBp), SBw, SBh, utf("spanisch"))
  dictGui.buttons.add _
      TGuiButton(posSearchTrans, SBx, SBy+3*(SBh+SBp), SBw, SBh, utf("deutsch"))

  ' show words
  dim as TPages pages = TPages(13, 40, 15, 15, 10, 180, 500, 550, 1)
  dim as TGuiButton tempButton
  pages.outp = @dictionaryOutput
  pages.colWidth = pages.colDist
  pages.calcPositions(exercise.currentList.list)
  page = 0
  do
    pages.barPos = 0
    screenlock
    cls
    line (0, 0)-step(SCREEN_X-1, LBy-1), &hffffff, bf
    pages.printEntries(exercise.currentList.list, page)
    ' show arrow buttons or not?
    if pages.pages.size = 1 then
      ' hide if only one page is shown
      if upState <> GuiState.hidden then
        dim as TGuiButton tempButton = dictGui.getButton(posUp)
        tempButton.state = GuiState.hidden
        dictGui.setButton(tempButton)
        upstate = GuiState.hidden
      end if
      if downState <> GuiState.hidden then
        dim as TGuiButton tempButton = dictGui.getButton(posDown)
        tempButton.state = GuiState.hidden
        dictGui.setButton(tempButton)
        downState = GuiState.hidden
      end if
    else
      if page = 0 then
        ' deactivate "up"
        if upState <> GuiState.deactivated then
          dim as TGuiButton tempButton = dictGui.getButton(posUp)
          tempButton.state = GuiState.deactivated
          dictGui.setButton(tempButton)
          upState = GuiState.deactivated
        end if
      else
        ' activate "up"
        if upState <> GuiState.active then
          dim as TGuiButton tempButton = dictGui.getButton(posUp)
          tempButton.state = GuiState.active
          dictGui.setButton(tempButton)
          upState = GuiState.active
        end if
      end if
      if page = pages.pages.size-1 then
        ' deactivate "down"
        if downState <> GuiState.deactivated then
          dim as TGuiButton tempButton = dictGui.getButton(posDown)
          tempButton.state = GuiState.deactivated
          dictGui.setButton(tempButton)
          downState = GuiState.deactivated
        end if
      else
        ' activate "down"
        if downState <> GuiState.active then
          dim as TGuiButton tempButton = dictGui.getButton(posDown)
          tempButton.state = GuiState.active
          dictGui.setButton(tempButton)
          downState = GuiState.active
        end if
      end if
    end if
    tempButton = dictGui.getButton(posSort+sorted)
    tempButton.state = GuiState.activated
    dictGui.setButton(tempButton)
    dictGui.show
    if len(searchString) < 21 then
      centerFT SBx+SBw\2, SBy+2*SBh, searchString, font, 10
    else
      centerFT SBx+SBw\2, SBy+2*SBh, left(searchString, 18) & "...", font, 10
    end if
    screenunlock
    do
      getmouse mx, my, wheel, mb
      sleep 1
    loop until mb < 1
    ' user input
    do
      key = inkey
      event = dictGui.getEvent(key)
      ' mark / speak words / show more info
      tempInt = iif(key = "0", -1, cint(key))
      if tempInt = 9 then tempInt = 0
      if tempInt orelse mb = 1 orelse mb = 2 then
        for i as integer = 0 to ubound(pages.wordPos)
          with pages.wordPos(i)
            if checkMouseIn(.x, .y-pages.wordDist\2, pages.colDist\2, .h+pages.wordDist) <> 0 then
              if tempInt then
                ' mark word
                word = globallist.get(.id)
                word.mark = iif(tempInt = -1 or word.mark = tempInt, 0, tempInt)
                globallist.put(.id, word)
                screenlock
                cls
                pages.printEntries(exercise.currentList.list, page)
                dictGui.show
                screenunlock
              elseif mb = 2 then
                ' speak word
                if spec <> 1 orelse i < pages.barPos then
                  dictGui.show GuiState.deactivated
                  speak globallist.get(.id).word
                  dictGui.show
                  exit for
                end if
              elseif mb = 1 then
                ' show info
                dim as FB.Image ptr tempImg = imagecreate(SCREEN_X, SCREEN_Y)
                get (0, 0)-(SCREEN_X-1, SCREEN_Y-1), tempImg
                wordInfo globallist.get(.id)
                put (0, 0), tempImg, pset
                imagedestroy tempImg
                exit for
              end if
            end if
          end with
        next
      end if
      ' GUI buttons
      select case event.id
        case posUp
          if page > 0 then
            page -= 1
            exit do
          end if
        case posDown
          if page < pages.pages.size-1 then
            page += 1
            exit do
          end if
        case posHelp
          dim as FB.Image ptr tempImg = imagecreate(SCREEN_X, SCREEN_Y)
          get (0, 0)-(SCREEN_X-1, SCREEN_Y-1), tempImg
          help LANGUAGE & "/doc.htm", "dictionary"
          put (0, 0), tempImg, pset
          imagedestroy tempImg
        case posSetting
          ' TODO
          'chooseWords(exercise)
          'list.clear
          'if exercise.currentList.size then
          '  list.addAll(exercise.currentList.list)
          '  count = exercise.currentlist.size
          'else
          '  list.addAll(exercise.fullList.list)
          '  count = exercise.fulllist.size
          'end if
          'pages.calcPositions(list)
          'page = 0
          'exit do
        case posSearch
          dim as string tempString = searchInput
          if tempString <> searchString then
            searchString = tempString
            exercise.currentList.list.clear
            dim as mdList(TListPoint) tempList
            tempList = dictionarySort(exercise.fullList.list, sorted, searchString, searchOpt)
            exercise.currentList.list.clear
            exercise.currentList.list.addAll(tempList)
            pages.calcPositions(exercise.currentList.list)
            page = 0
            exit do
          end if
        case is > posSort
          if sorted <> event.id - posSort then
            tempButton = dictGui.getButton(posSort+sorted)
            tempButton.state = GuiState.active
            dictGui.setButton(tempButton)
            tempButton.show
            sorted = event.id - posSort
            tempButton = dictGui.getButton(event.id)
            tempButton.state = GuiState.activated
            dictGui.setButton(tempButton)
            tempButton.show
            dim as mdList(TListPoint) tempList
            tempList = dictionarySort(exercise.currentList.list, event.id-posSort, searchString, searchOpt)
            exercise.currentList.list.clear
            exercise.currentList.list.addAll(tempList)
            'exercise.fullList.list.clear
            'exercise.fullList.list.addAll(tempList)
            pages.calcPositions(exercise.currentList.list)
            page = 0
            exit do
          end if
        case posBack
          exit do, do
      end select
      sleep 1
    loop until key = chr(255, 107)
  loop until key = chr(27) or key = chr(255, 107)
end sub
